#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "FrameDelay", Category = "Transform", Help = "Basic template with one transform in/out", Tags = "matrix")]
	#endregion PluginInfo
	public class TransformFrameDelayNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input")]
		ISpread<Matrix4x4> FInput;

		[Output("Output")]
		ISpread<Matrix4x4> FOutput;
		[Output("tempbuffer")]
		ISpread<Matrix4x4> Fbuffer;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			Fbuffer.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++)
			{
				FOutput[i] = Fbuffer[i];
				Fbuffer[i] = FInput[i];
			}

			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
		}
	}
}
